#include "GLBaseBreeder.h"
#include "GLBaseCrossover.h"
#include "GLRuntimeError.h"
/**
 * Simple constructor. Assigns the crossover which will be used for
 * breeding.
 */
GLBaseBreeder::GLBaseBreeder(GLBaseCrossover* crossover)
{
  if (crossover == NULL)
  {
    char errormsg[] = "\nGLBaseBreeder::GLBaseBreeder\n"
                      "Null argument is passed as a parameter 'crossover'\n";
    throw GLRuntimeError(errormsg);
  }
  m_crossover = crossover;
}//constructor

GLBaseBreeder::~GLBaseBreeder()
{
  if (m_crossover != NULL) delete m_crossover;
}//destructor


/**
 * Resets breeder (e.g. sets counter, if any, to zero etc.) and its
 * crossover.
 */
void GLBaseBreeder::reset()
  {
    getCrossover()->reset();
  }//reset
