#ifndef GLBASECROSSOVER_H_
#define GLBASECROSSOVER_H_

#include "GLBaseOrganism.h"
/**
 * Base class for crossover algorithm.
 */
class GLBaseCrossover
{
public:
  /**
   * Simple constructor.
   */
  GLBaseCrossover() {};
  /**
   * Simple destructor, destroys everything.
   */
  virtual ~GLBaseCrossover(){};

  /**
   * Creates an offspring from the vector of parents. Note, that the number
   * of parents can be arbitrary, although normally 2 parents are used.
   * @param parents vector of parents.
   * @param children vector of new organisms obtained from parents. Previous
   *    content will not be preserved.
   */
  virtual void makeOffsprings(const vector<GLBaseOrganism*>& parents,
                              vector<GLBaseOrganism*>& children) = 0;

  /**
   * Resets the crossover (e.g. sets counter, if any, to zero etc.).
   */
  virtual void reset() {};
};

#endif /*GLBASECROSSOVER_H_*/
