#ifndef GLBASEGASTOPPER_H_
#define GLBASEGASTOPPER_H_
#include <list>
class GLBaseGaStatus;

/**
 * Class to provide the method which determines when to stop the GA.
 */
class GLBaseGaStopper
{
public:
  /**
   * Simple constructor.
   */
  GLBaseGaStopper() {};

  /**
   * Simple destructor.
   */
  virtual ~GLBaseGaStopper() {};

  /**
   * Method which determines whether it is time to stop a GA based on its
   * status.
   * @param ga_status current status of the ga.
   * @return true when GA should stop.
   */
  virtual bool stop(const GLBaseGaStatus* ga_status) = 0;
};

typedef std::list<GLBaseGaStopper*> TListOfStoppers;
#endif /*GLBASEGASTOPPER_H_*/
