#include "GLBaseOrganism.h"
#include "GLBaseRanker.h"

GLBaseRanker::GLBaseRanker()
{
}

GLBaseRanker::~GLBaseRanker()
{
}

/**
 * Returns the index of the first not-evaluated organisms in the array
 * or -1 if all are evaluated.
 * @param organisms vector of organisms to be checked.
 * @return true if all of the organisms are evaluated and false otherwise.
 */
int GLBaseRanker::notEvaluated(
      const vector<const GLBaseOrganism*>& organisms) const
  {
    for(size_t i = 0; i < organisms.size(); i++)
    {
      if (!organisms[i]->isEvaluated()) return i;
    }
    return -1;
  }//notEvaluated

/**
 * Resets the ranker (e.g. sets counter, if any, to zero etc.).
 */
void GLBaseRanker::reset()
  {
    
  }//reset
