#include <NLstl_utils.h>

#include "GLBaseMutator.h"
#include "GLBaseVariator.h"
/**
 * Constructor. Takes the pointer to mutator operator.
 * @param mutator mutator operator.
 */
GLBaseVariator::GLBaseVariator(GLBaseMutator *mutator)
{
  nlutils::assertPointer(mutator, "from GLBaseVariator::GLBaseVariator");
  m_mutator = mutator;
}//constructor

/**
 * Deletes all, including mutator operator.
 */
GLBaseVariator::~GLBaseVariator()
{
  if (m_mutator != NULL)
    {
      delete m_mutator;
    }
}//destructor


/**
 * Resets the variator (e.g. sets counter, if any, to zero etc.) and its
 * mutator.
 */
void GLBaseVariator::reset()
  {
    
  }//reset
