#ifndef GLCROSSOVERONEPOINT_H_
#define GLCROSSOVERONEPOINT_H_

#include "GLBaseCrossover.h"

/**
 * Standard one-point crossover which choses the point in one parent
 * and then swaps the tails with another. 
 * This crossover can be applied to all organisms which implement
 *      GLInterfaceSwapTails 
 */
class GLCrossoverOnePoint : public GLBaseCrossover
{
public:
  /**
   * Simple empty constructor.
   */
  GLCrossoverOnePoint() {};
  
  /**
   * Destructor -- destroys everything. 
   */
  virtual ~GLCrossoverOnePoint() {};

  /**
   * Creates an 2 offsprings from 2 parents by randomly swapping tails.
   * @param parents vector of parents.
   * @param children vector of new organisms obtained from parents. Previous
   *    content will not be preserved.
   */
  virtual void makeOffsprings(const vector<GLBaseOrganism*>& parents,
                              vector<GLBaseOrganism*>& children);
};

#endif /*GLCROSSOVERONEPOINT_H_*/
