#ifndef GLCROSSOVERTWOPOINTS_H_
#define GLCROSSOVERTWOPOINTS_H_

#include "GLBaseCrossover.h"

/**
 * Class for two-point crossover -- swaps the section of organisms
 * between 2 genes. Organisms should implement GLInterfaceSwapSection. 
 */
class GLCrossoverTwoPoints : public GLBaseCrossover
{
public:
  /**
   * Simple empty constructor.
   */
  GLCrossoverTwoPoints() {};
  /**
   * Destructor. Destroys everything.
   */
  virtual ~GLCrossoverTwoPoints() {};

  /**
   * Creates an 2 offsprings from 2 parents by swapping sections bounded
   * by randomly chosen 2 points.
   * @param parents vector of parents. Must contain only 2 elements each of
   *    them implementing GLInterfaceSwapSections.
   * @param children vector of new organisms obtained from parents. Previous
   *    content will not be preserved.
   */
  virtual void makeOffsprings(const vector<GLBaseOrganism*>& parents,
                              vector<GLBaseOrganism*>& children);
  
};

#endif /*GLCROSSOVERTWOPOINTS_H_*/
