#include <NLstl_utils.h>
#include "GLFitnessSingleObjective.h"

/**
 * Simple destructor.
 */
template<class TFitness>
GLFitnessSingleObjective<TFitness>::~GLFitnessSingleObjective()
{
}//destructor

/**
 * Assigns the value of fitness function GLFitnessSingleObjective<double>.
 * Note, that it means, that template parameter TFitness must support
 * transformation to double.
 * @param result should be compatible with type 
 *   GLFitnessSingleObjective<double>. E.g. this function may be
 *   used to transform GLFitness<int> to GLFitnessSingleObjective<double>.
 */
template<class TFitness>
void GLFitnessSingleObjective<TFitness>::assignTo(
                      GLBaseFitness& result) const
{
  GLFitness<double>* res =
      nlutils::transform_pointer<GLFitnessSingleObjective<double>,
                                 GLBaseFitness>(
          &result,
          "\nGLFitnessSingleObjective<TFitness>::assignTo\n"
          "Parameter 'result' must be of or inherited from type "
          "GLFitnessSingleObjective<double>\n");
  res->setValue(this->getValue());
}//getProduct
