#include <NLstl_utils.h>

#include "GLGaStatusStandard.h"
#include "GLGaStopperMaxGenerations.h"

/**
 * Constructor.
 * @param max_generations number of generations to run before stop.
 */
GLGaStopperMaxGenerations::GLGaStopperMaxGenerations(int max_generations)
{
  m_max_generations = max_generations;
}//constructor

/**
 * Method which determines whether it is time to stop a GA based on its
 * status.
 * @param ga_status current status of the ga (should point to the exemplar
 *  of GLGaStatusStandard class).
 * @return true when GA should stop.
 */
bool GLGaStopperMaxGenerations::stop(const GLBaseGaStatus* ga_status)
  {
    const GLGaStatusStandard* status = 
      nlutils::transform_pointer<const GLGaStatusStandard, 
                                 const GLBaseGaStatus>
        (ga_status, "GLGaStopperMaxGenerations::stop\n"
                    "Passed status is not a pointer to GLGaStatusStandard\n");
    return (status->m_current_generation >= m_max_generations); 
  }//stop
