#ifndef GLINITIALISERSHUFFLEINTVECTOR_H_
#define GLINITIALISERSHUFFLEINTVECTOR_H_

#include "GLBaseOrganismInitialiser.h"

class GLBaseOrganism;
/**
 * Class for creating GLOrganismVector<int> initialised with vector of
 * shuffled integer. The size of the organisms determined by the parameter
 * 'size' of this class.
 */
class GLInitialiserShuffleIntVector : public GLBaseOrganismInitialiser
{
public:
  /**
   * Simple default constructor.
   */
  GLInitialiserShuffleIntVector(int size)
    { setSize(size); }
  /**
   * Destructor, destroys everything. 
   */
  virtual ~GLInitialiserShuffleIntVector() {};
  
  /**
   * Return the current valut of size parameter.
   * @return the current value of size parameter.
   */
  int getSize() const
  { return m_size; }
  
  /**
   * Creates and initialise GLOrganismVector<int> and initialises it with
   * randomly shuffled vector of integer from 0 to getSize().
   * @return pointer to the organism initialised with some initial value.
   */
  virtual GLBaseOrganism* initialiseOrganism();

  /**
   * Set the size for newly generated organisms.
   * @param size new size.
   */
  void setSize(int size);
  
private:
  int m_size;
};

#endif /*GLINITIALISERSHUFFLEINTVECTOR_H_*/
