#ifndef GLINTERFACEMOVEGENE_H_
#define GLINTERFACEMOVEGENE_H_

/**
 * Interface for organisms which can move gene from one position to another
 * within the organism.
 */
class GLInterfaceMoveGene
{
public:
  /**
   * Moves the genes from one position to another.
   * @param old_position where the gene is moving from.
   * @param new_position where the gene is moving to.
   */
  virtual void moveGene(int old_position, int new_position) = 0; 
};

#endif /*GLINTERFACEMOVEGENE_H_*/
