#ifndef GLINTERFACESHUFFLEGENES_H_
#define GLINTERFACESHUFFLEGENES_H_

/**
 * Provides interface for genes shuffling.
 */
class GLInterfaceShuffleGenes
{
public:
  /**
   * Shuffles the set of genes in the organism. Genes which are
   * in the positions from the gene_numbers vector will be randomly
   * shuffled. Genes from other positions will stay where they are.
   * @param gene_numbers vector of positions of the genes to be shuffled.
   */
  virtual void shuffleGenes(const vector<int>& gene_numbers) = 0;
};

#endif /*GLINTERFACESHUFFLEGENES_H_*/
