#ifndef GLINTERFACESWAPTAILS_H_
#define GLINTERFACESWAPTAILS_H_

class GLBaseOrganism;
/**
 * Interface which allows one organism to swap tails with another.
 * For use in crossovers.
 */
class GLInterfaceSwapTails
{
public:
  /**
   * Swaps tails with another organism. After this method is called
   * the current organism should have tail of the anotherOrganism, while
   * the latter will have the tail of the caller.
   * @param anotherOrganism organism with which the swap will be done.
   * @param pos the place where the tails are swapped (element [i] will
   *    be swapped too).
   */
  virtual void swapTails(GLBaseOrganism* anotherOrganism, int pos) = 0;
};

#endif /*GLINTERFACESWAPTAILS_H_*/
