#ifndef GLRUNTIMEERROR_H_
#define GLRUNTIMEERROR_H_

#include <stdexcept>
#include <string>
using namespace std;

/**
 * Error to be thrown in case of logical (usually non-critical) error.
 */
class GLRuntimeError: public runtime_error
{
public: 
  /**
   * Creates the RuntimeError class.
   * @param msg message associated with the error.
   */
  GLRuntimeError(const string& msg = ""):
      runtime_error(msg)
   {}
  
  /**
   * Just a destructor.
   */
   virtual ~GLRuntimeError() throw(){};
};//GLRuntimeError

#endif /*GLRUNTIMEERROR_H_*/
