#ifndef GLTESTEVALUATOR_H_
#define GLTESTEVALUATOR_H_

#include "GLBaseEvaluator.h"

/**
 * Simple evaluator of the organism to be used for test purposes. 
 */
class GLTestEvaluator : public GLBaseEvaluator
{
public:
  /**
   * Simple constructor.
   */
  GLTestEvaluator();
  /**
   * Destructor, destroys everything.
   */
  virtual ~GLTestEvaluator(){};
	  
  /**
   * Evaluates fitness function of the organism. Requires organism to
   * be pointer to GLOrganismVector<int>. Returns the sum of absolute 
   * differences between neighbours in the vector of integers.
   * @param organism organism to be evaluated.
   * @return fitness value storage -- GLFitness<int>*.
   */
  virtual GLBaseFitness* evaluateOrganism(GLBaseOrganism* organism);

  /**
   * Returns the number of objectives in fittness function. Makes it
   * possible to distinguish between single and multiple objective
   * optimisation even if the same GA is used for optimisation.
   * @return 1.
   */
  virtual int getNumberOfObjectives() const
    { return 1; };

};

#endif /*GLTESTEVALUATOR_H_*/
