#ifndef NLINTERFACEOUTPUT_H_
#define NLINTERFACEOUTPUT_H_
#include <iostream>
using namespace std;

namespace nlutils
{
class NLInterfaceOutput
{
public:
    /**
     * Outputs the class to output stream.
     * @param out output stream.
     */
    virtual ostream& toStream(ostream& out) const
      { 
        out << "Output for this class was not defined "
               "(define toStream method)\n"; 
        return out; 
      }

    /**
     * Outputs the content of the organism to output stream in
     * debug mode. By default the output the same as 'normal' output.
     * @param out output stream.
     */
    virtual ostream& toStreamDebug(ostream& out) const
      { return out; }
};//class NLInterfaceOutput
};

/**
 * To provide output-to-stream operator for all classes implementing
 * this NLInterfaceOutput interface.
 * @param out output stream
 * @param source instance of class implementing NLInterfaceOutput interface.
 * @return output stream. 
 */
inline ostream& operator<<(ostream& out, nlutils::NLInterfaceOutput& source)
  {
    return source.toStream(out);
  }

/**
 * To provide output-to-stream operator for all classes implementing
 * this NLInterfaceOutput interface.
 * @param out output stream
 * @param source instance of class implementing NLInterfaceOutput interface.
 * @return output stream. 
 */
inline ostream& operator<<(ostream& out, 
                           const nlutils::NLInterfaceOutput& source)
  {
    return source.toStream(out);
  }
#endif /*NLINTERFACEOUTPUT_H_*/
